# 更新說明

---

### Version 1.4.9 (20201223)

##### Web

1. 修正手動模式下無法正常下棋的錯誤
2. 修正斷線中盤和中盤對下累計時間錯誤

##### Client

1. DCTP (DarkChess Text Protocol) 更名為 MGTP (Multiple Games Text Protocol)
2. 新增顯示 Search 資訊
3. 調整斷線中盤和中盤對下先後手設置問題
4. 修正斷線中盤和中盤對下累計時間錯誤
5. 修正 MGTP mode 下傳送失敗訊息造成 client crash 的問題
6. 修正 ReadFile mode 下 board.txt 檔案每手時間錯誤的問題
7. 修正 CLI mode 下比賽模式無法成功加入比賽問題

##### Server

1. 調整斷線中盤和中盤對下先後手設置問題

### Version 1.4.8 (20200810)

##### Web

1. 歷史盤面修正

### Version 1.4.7 (20200729)

##### Server

1. 調整中盤的先後手。選擇中盤對下且先手，則表示為該中盤盤面的先手，不是接下來先手。

##### Client

1. 修正中盤下顏色顯示問題
2. 修正歷史盤面卷軸錯誤問題
3. 現在 Search 和 盤面路徑錯誤不刪除資料
4. 修正 ReadFile 模式下多餘的空白問題

##### Web

1. 調整翻棋底色
2. 歷史盤面可使用 WASD 或方向鍵來操控

### Version 1.4.6 (20200717)

##### Web

1. 修正時間顯示問題

### Version 1.4.5 (20200714)

##### Client

1. 修正 cli 模式下錯誤問題

##### Web

1. 修正時間顯示問題

### Version 1.4.4 (20200604)

##### Client

1. 修改 Human 模式下顯示錯誤

##### Web

1. 修正中盤盤面開啟錯誤

### Version 1.4.3 (20200531)

##### Client

1. 顯示更新資訊
2. 新增錯誤紀錄回報
3. 修正顯示位置

##### Web

1. 修正盤面顯示錯誤問題

### Version 1.4.2 (20200524)

##### Client

1. 修正盤面顏色錯誤問題

### Version 1.4.1 (20200522)

##### Client

1. 修正比賽模式中盤面紀錄消失問題
2. 修正中途開啟盤面觀看相關錯誤

### Version 1.4.0 (20200513)

##### Client

1. 提供比賽功能
2. 提供CLI mode 遠端頁面功能
3. 可在中途重新開啟盤面觀看
4. 新增多項顯示頁面
5. 修正多項錯誤

##### Web

1. 顯示多項額外資訊
2. 修正多項錯誤

### Version 1.3.3 (20191217)

##### Client

1. 調整顯示文字

##### Web

1. 調整History版面配置
2. 調整顯示文字

---

### Version 1.3.2 (20191212)

##### Client

1. 限制輸入數字數值上限
2. 顯示可能錯誤訊息原因

##### Web

1. 限制鍵盤使用功能
2. history顯示檔案名稱
3. history顯示先後手

---

### Version 1.3.1 (20191010)

##### Client

1. 修正設定頁面選項設定錯誤問題
2. 修正房間清單顯示錯誤問題
3. 修改 Timer 等待時 CPU 使用率
4. 調整非同步接收訊息實作方法
5. 修正讀檔模式下 board.txt 錯誤問題
6. 新增顯示盤面設定錯誤訊息
7. Ponder 新增 Exit 指令來強制程式關閉

##### Server

1. 修改盤面 log 勝負寫反的問題
2. 設定盤面會回報錯誤訊息
3. 盤面 log 的檔名會標示贏家名稱
4. 修正非法走步造成程式崩潰問題
5. 新增顯示盤面設定錯誤訊息
6. 調整 log 內第一行紀錄時間為遊戲開始的時間

---

### Version 1.3.0 (20190731)

##### Web

1. 新增Undo模式

##### Client

1. 新增Undo模式
2. 調整盤面紀錄檔案顯示字樣
3. 降低Human模式下系統使用資源
4. 修改盤面紀錄格式
5. 修改使用中盤盤面，房間倒數計時器未扣除中盤花費時間
6. 修正填入非數字在數字欄位中，程式無法關閉的問題

##### Server

1. 盤面新增玩家勝負

##### LocalServer

1. 新增Undo模式

---

### Version 1.2.2 (20190719)

##### Web

1. 更改中盤格式

##### Client

1. 更改中盤格式

---

### Version 1.2.1 (20190714)

##### Web

1. 修正歷史盤面檔案過大造成無法開啟的問題
2. 取消在AI模式下棋子可以點擊
3. 修正製作中盤盤面步數錯誤問題
4. 修正history新舊版本相容問題
5. 提供WASD控制步數功能

##### Client

4. 新增刪除最後一場遊戲輸出的開關
5. illegalAction附上非法走步
6. 中盤副檔名限制使用.DEBUG
7. 發生錯誤時停止計時器計時
8. 新增中盤盤面格式確認

##### Server

1. illegalAction附上非法走步
2. 時間設0為不計時
3. 修正中盤檢查機制

##### LocalServer

1. illegalAction附上非法走步
2. 改為檢查所有最新版本號
3. 時間設0為不計時
4. 修正中盤檢查機制

---

### Version 1.1.1 (20190607)

##### Web

1. 修正歷史盤面讀取完直接製作中盤盤面檔案錯誤。
2. 修正手動模式中對方移動顯示消失問題。

##### Client

2. 修正可能出現log檔案開啟無法寫入及刪除問題。

---

### Version 1.1.0 (20190606)

##### Web

1. 加快歷史盤面讀取速度。
2. 顯示遊戲結果和原因。
3. 修改顯示字體。
4. 新增提和/認負功能。
5. 新增字體顏色代表我方顏色。(藍色: Unknown)
6. 歷史頁面歷史輸出框調整位置。

##### Client

7. 新增房間內顯示玩家類別項目。
8. 新增提和/認負功能。
9. 中盤對下輸出盤面錯誤修正。
10. 時間倒數顯示結束遊戲時停止倒數。
11. 超時訊息接收修正。
12. 調整AI路徑欄位表示方法。
13. 修正加房後不選擇房間再次重新加房出現Port佔用問題。
14. 由伺服器傳送更新網址。
15. 修正遊戲紀錄圓餅圖顯示錯誤問題。

##### Server

1. 新增提和/認負功能。
2. 超時訊息接收修正。

##### LocalServer

1. 新增提和/認負功能。
2. 超時訊息接收修正。

---

### Version 1.0.1 (20190507)

##### Web

2. 修正本地測試時，網頁盤面顯示卡住問題。
3. 更改箭頭樣式。

##### Search

1. 修改範例程式 Search.exe 對於不同compiler和OS的相容性問題。

##### Client

1. 支援中文檔案路徑。
2. 調整遊戲紀錄列表內容格式。
3. 更換遊戲紀錄圖表顯示library，加快顯示速度。
4. 修正board檔內時間格式錯誤。

##### LocalServer

1. 修正board檔內時間格式錯誤。

---

### Version 1.0.0 (20190425)

新增暗棋遊戲。